from django.utils import timezone
from django.utils.deprecation import MiddlewareMixin

from guichet.models import Registration


class PendingPaymentMiddleware(MiddlewareMixin):
    def process_view(self, request, view, view_args, view_kwargs):

        if request.user.is_authenticated:
            registrations = request.user.registrations.exclude(info_state=Registration.STATE_CANNOT_PAID).filter(
                paid=False, ticket__event__end_date__gt=timezone.now()
            )
            request.pending_payment = registrations.exists()

            registrations_cannot_enter = request.user.registrations.exclude(
                info_state=Registration.STATE_CAN_ENTER
            ).filter(ticket__event__end_date__gt=timezone.now())
            request.pending_document = registrations_cannot_enter.exists()
